import java.util.concurrent.locks.*;
/*@
lemma void remove_all_head<t>(list<t> xs, list<t>ys)
    requires true;
    ensures remove_all(xs, ys) == remove_all(tail(xs), remove(head(xs), ys));
 {
    assume(false);
 }
    
predicate_ctor lock_inv(SharedVariable v)(;) = v.value |-> _;

predicate locks(list<SharedVariable> vs; list<ReentrantLock> ll) =
    vs == nil ? ll == nil : [_]head(vs).lock |-> ?lock &*& [_]lock.ReentrantLock(lock_inv(head(vs))) &*& locks(tail(vs), ?ll0) &*& ll == cons(lock,ll0) &*& lock_above_all(lock,ll0) == true;

predicate invariants(list<SharedVariable> vs;) =
	vs == nil ? 
	true 
	: 
	lock_inv(head(vs))() &*& invariants(tail(vs));
	
lemma void the_lemma(ReentrantLock x, list<ReentrantLock> xs, list<ReentrantLock> ys)
    requires lock_all_below_all(xs, ys) == true &*& lock_above_all(x,xs)== true;
    ensures lock_all_below_all(xs, cons(x, ys)) == true;
{
     switch (xs) {
        case nil:
        case cons(h, t):
           the_lemma(x, t, ys);
    }
 }
 @*/
 
 /*@lemma_auto void locks_inv()
    requires [?f]locks(?vs, ?ls);
    ensures [f]locks(vs, ls) &*& vs != nil || ls == nil;
    {
    open locks(vs, ls);
    }
@*/

/*@


predicate locked(list<SharedVariable> vs, int t;) = 
    vs == nil ?
    true 
    :
    [_]head(vs).lock |-> ?lock &*& lock.ReentrantLocked(lock_inv(head(vs)), t, _) &*& locked(tail(vs),t);

@*/
class Statement {
    SharedVariableList variablesList;
    //@ predicate Statement_lock(list<SharedVariable> vs,list<ReentrantLock> ll) = this.variablesList |-> ?a &*& a != null  &*& a.List(vs) &*& locks(vs,ll);
    //@ predicate Statement_locked(list<SharedVariable> vs,list<ReentrantLock> ll) = this.variablesList |-> ?a &*& a != null  &*& a.List(vs) &*& locks(vs,ll);
    void lock()
        //@ requires [_]Statement_lock(?vs,?ll) &*& lockset(currentThread,?levelsList) &*& lock_all_below_all(ll,levelsList) == true;
        //@ ensures invariants(vs) &*& lockset(currentThread,append(reverse(ll),levelsList)) &*& locked(vs,currentThread);
    {
        for (int i = 0; i < variablesList.size(); i++)
        //@ requires [_]variablesList |-> ?b &*& [_]b.List(vs) &*& [_]locks(drop(i,vs),?ll1) &*& i >= 0 &*& i <= length(vs)&*& lockset(currentThread,?levelsList1) &*& lock_all_below_all(ll1,levelsList1) == true;
       //@ ensures invariants(drop(old_i, vs)) &*& lockset(currentThread,append(reverse(ll1),levelsList1)) &*& locked(drop(old_i, vs), currentThread);
        {
            //@ drop_n_plus_one(i,vs);
            //@ switch (levelsList1) { case nil: case cons(h,t): }
            //@ open(locks(_,_));
            //@ the_lemma(head(ll1), tail(ll1), levelsList1);
            //@ append_assoc(reverse(tail(ll1)), {head(ll1)}, levelsList1);
           variablesList.get(i).lock.lock();
        }
    }
   
    void unlock()
    //@ requires [_]Statement_lock(?vs,?ll) &*& invariants(vs) &*& lockset(currentThread,?levelList) &*& locked(vs,currentThread);
    //@ ensures lockset(currentThread, remove_all(ll,levelList));

    {
        for (int  i = 0; i < variablesList.size(); i++)
        //@requires [_]variablesList |-> ?b &*& [_]b.List(vs) &*& [_]locks(drop(i,vs),?ll1) &*& invariants(drop(i,vs)) &*& i >= 0 &*& i <= length(vs) &*& lockset(currentThread,?levelList1) &*& locked(drop(i,vs),currentThread);
        //@ ensures lockset(currentThread,remove_all(ll1,levelList1));
        { 
            //@ drop_n_plus_one(i,vs);
           //@ open(locked(_,_));
           //@ open(locks(_,_));
           //@ remove_all_head(ll1, levelList1);
            variablesList.get(i).lock.unlock();
        }
    }
    
}
